config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  resources :posts do
    resources :comments, shallow: true
  end
  resources :comments

  root :to => "posts#index_public"

end

app/models/comment.rb
class Comment < ActiveRecord::Base
  belongs_to :post
  belongs_to :user
  validates :body, presence: true
  validates :post_id, presence: true
  scope :desc, -> { order(created_at: :desc) }
end

app/models/post.rb
class Post < ActiveRecord::Base
  belongs_to :user
  has_many :comments, dependent: :destroy
  validates :title, presence: true
  validates :body, presence: true
  validates :user_id, presence: true
  scope :desc, -> { order(created_at: :desc) }
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :posts, dependent: :destroy
  has_many :comments, dependent: :destroy
  
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :set_comment, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!, only: [:edit, :update, :destroy, :index]
  
  # GET /comments
  # GET /comments.json
  def index
    @comments = Post.find(params[:post_id]).comments
  end

  # GET /comments/1
  # GET /comments/1.json
  def show
  end

  # GET /comments/new
  def new
    @comment = Comment.new
  end

  # GET /comments/1/edit
  def edit
  end

  # POST /comments
  # POST /comments.json
  def create
    @post = Post.find(params[:post_id])
    @comment = @post.comments.create(comment_params)

    if !current_user.nil?
      current_user.comments << @comment
    end
    
    respond_to do |format|
      if @comment.save
        format.html { redirect_to @post, notice: 'Comment was successfully created.' }
        format.json { render :show, status: :created, location: @comment }
        format.js { render :show, status: :created, location: @comment }
      else
        format.html { render :new }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /comments/1
  # PATCH/PUT /comments/1.json
  def update
    respond_to do |format|
      if @comment.update(comment_params)
        format.html { redirect_to @comment, notice: 'Comment was successfully updated.' }
        format.json { render :show, status: :ok, location: @comment }
      else
        format.html { render :edit }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /comments/1
  # DELETE /comments/1.json
  def destroy
    post = Post.find(@comment.post.id)

    @comment.destroy
    respond_to do |format|
      format.html { redirect_to post_comments_path(post), notice: 'Comment was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    def set_comment
      @comment = Comment.find(params[:id])
    end


    def comment_params
      params.require(:comment).permit(:post_id, :body)
    end

    def comment_params_user
      params.require(:comment).permit(:post_id, :body)
      params.require(:user).permit(:user_id)
    end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!, except: [:show, :index_public]

  # GET /posts
  # GET /posts.json
  def index
    @posts = current_user.posts.all.desc
  end

  # Endpoint for home page
  # GET /
  def index_public
    @posts = Post.all.desc

    respond_to do |format|
        format.html { render 'posts/home', location: @post }
    end
  end

  
  # GET /posts/1
  # GET /posts/1.json
  def show
  end

  # GET /posts/new
  def new
    @post = Post.new
  end

  # GET /posts/1/edit
  def edit
  end

  # POST /posts
  # POST /posts.json
  def create
    @post = current_user.posts.create(post_params)

    respond_to do |format|
      if @post.save
        format.html { redirect_to @post, notice: 'Post was successfully created.' }
        format.json { render :show, status: :created, location: @post }
      else
        format.html { render :new }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /posts/1
  # PATCH/PUT /posts/1.json
  def update
    respond_to do |format|
      if @post.update(post_params)
        format.html { redirect_to @post, notice: 'Post was successfully updated.' }
        format.json { render :show, status: :ok, location: @post }
      else
        format.html { render :edit }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /posts/1
  # DELETE /posts/1.json
  def destroy
    @post.destroy
    respond_to do |format|
      format.html { redirect_to posts_url, notice: 'Post was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    def set_post
      @post = Post.find(params[:id])
    end

    def post_params
      params.require(:post).permit(:title, :body)
    end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/comments/_comment.html.erb
<%= div_for comment do %>
  
  <p>
	<%= h(comment.body) %>
  </p>
  <small>Posted <%= time_ago_in_words(comment.created_at) %></small>
  <% if !comment.user.nil? %>
    <small>by: <%= comment.user.email %></small>
  <% else %>
    <small>by: anonymous</small>
  <% end %>
  <hr class="divider" >
<% end %>

app/views/comments/_form.html.erb
<%= form_for(@comment) do |f| %>
  <% if @comment.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@comment.errors.count, "error") %> prohibited this comment from being saved:</h2>

      <ul>
      <% @comment.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :post_id %><br>
    <%= f.text_field :post_id %>
  </div>
  <div class="field">
    <%= f.label :body %><br>
    <%= f.text_area :body %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/comments/edit.html.erb
<h1>Editing Comment</h1>

<%= render 'form' %>

app/views/comments/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Comments</h1>

<table class="table">
  <thead>
    <tr>
      <th>Comment text</th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @comments.each do |comment| %>
      <tr>
        <td>
          <% if !comment.user.nil? && comment.user.id == current_user.id %>
            <%= link_to 'Edit', edit_comment_path(comment), :class => "btn btn-default" %>
          <% else %>

          <% end %>
          <%= truncate(comment.body, length: 60) %>
        </td>
        <td>
          <%= link_to 'Destroy', comment_path(comment), method: :delete, data: { confirm: 'Are you sure?' }, :class => "btn btn-danger" %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

app/views/comments/new.html.erb
<h1>New Comment</h1>

<%= render 'form' %>

<%= link_to 'Back', comments_path %>

app/views/comments/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Post:</strong>
  <%= @comment.post %>
</p>

<p>
  <strong>Body:</strong>
  <%= @comment.body %>
</p>

<%= link_to 'Edit', edit_comment_path(@comment) %>

app/views/comments/show.js.erb
$('#comments').prepend("<%= j (render @comment) %>");
$('#new_comment')[0].reset();
$('#none-holder').hide();

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Blog</title>
    <!-- Latest compiled and minified CSS -->
    <%=stylesheet_link_tag "application", media: "all" %>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/css/bootstrap.min.css" integrity="sha512-dTfge/zgoMYpP7QbHy4gWMEGsbsdZeCXz7irItjcC3sPUFtf0kuFbDz/ixG7ArTxmDjLXDmezHubeNikyKGVyQ==" crossorigin="anonymous">
    <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
    <%= csrf_meta_tags %>
  </head>

  <body>

    <div id="header" class="navbar-fixed-top row-fluid">
      <div class="container">
        <h1>
          <%= link_to "Javier's Blog", root_path, :id => "header-text"%>
        </h1>
        <% if user_signed_in? %>
          <div class="pull-right">
            <%= link_to 'Admin', posts_path, :style => "color: white;" %>
            <%= link_to 'Logout',
            destroy_user_session_path(current_user),
            data: { confirm: 'Are you sure?' },
            method: :delete,
            :style => "color: white;" %>
            
            <% if !@post.nil? %>
              <%#= link_to 'Edit', edit_post_path(@post) %>              
            <% end %>
            
          </div>
        <% else %>
          <div class="pull-right">
            <%= link_to 'Login', new_user_session_path, :style => "color: white;" %>
          </div>

        <% end %>

      </div>
    </div>
    
    <div style="margin-top: 240px;"class="container">
      <%= yield %>
    </div>
    
    <footer class="footer navbar-bottom">
      <div class="container">
        <p class="text-muted">Made with ❤️  by Javier Chavez</p>
      </div>
    </footer>
    
  </body>
</html>

app/views/posts/_form.html.erb
<%= form_for(@post) do |f| %>
  <% if @post.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@post.errors.count, "error") %> prohibited this post from being saved:</h2>

      <ul>
      <% @post.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= f.label :title %><br>
    <%= f.text_field :title, :class=>"form-control" %>
  </div>
  <div class="form-group">
    <%= f.label :body %><br>
    <%= f.text_area :body, :class=>"form-control" %>
  </div>
  <div class="actions">
    <%= f.submit "Save", :class => "btn btn-primary pull-right" %>
  </div>
<% end %>

app/views/posts/edit.html.erb
<h1>Editing Post</h1>

<%= render 'form' %>

app/views/posts/home.html.erb
<% @posts.each do |post| %>
  
  <div class="page-header">
    <h1><%= link_to post.title, post %></h1>
    <div>
      <small>Posted <%= time_ago_in_words(post.created_at) %></small>
    </div>
    <div>
      <small>By: <%= post.user.email %></small>
    </div>
  </div>

  <div class="container-fluid post-list-item">
    <div class="row">
      <p class="lead">
        <%= truncate(post.body, length: 200, :omission => '...') %>
      </p>
    </div>
  </div>
  <em>
    <small class="pull-right">
      <%= post.comments.count%> <%= " Comment".pluralize(post.comments.count) %>
    </small>
  </em>

<% end %>

app/views/posts/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Posts</h1>
<div class="table-responsive">
  <table class="table">
    <thead>
      <tr>
        <th>Title</th>
        <th></th>
      </tr>
    </thead>

    <tbody>
      <% @posts.each do |post| %>
        <tr>
          <td>
            <%= link_to post.title, post %></br>
            <small class="pull-right"><%= post.created_at.to_s(:long) %></small>
          </td>
          <td>
              <%= link_to 'Edit', edit_post_path(post), :class => "btn btn-primary" %>
              <%= link_to "Manage Comments", post_comments_path(post), :class => "btn btn-default" %>
              <%= link_to "delete", post, method: :delete, data: { confirm: 'Are you sure?' }, :class => "btn btn-danger" %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>
<br>

<%= link_to 'New Post', new_post_path, :class => "btn btn-success" %>

app/views/posts/new.html.erb
<h1>New Post</h1>

<%= render 'form' %>

<%= link_to 'Back', posts_path %>

app/views/posts/show.html.erb
<p id="notice"><%= notice %></p>



<div class="page-header">  
  <h1><%= @post.title %></h1>
</div>



<div class="container-fluid" style="padding-bottom: 70px;">
  <div class="row">
    <p class="lead">
      <%= @post.body %>
    </p>
  </div>
</div>




<div class="container-fluid">
  <div class="row">
    
    <%= form_for([@post, Comment.new], remote: true) do |f| %>
      <p>
        <div class="form-group">
          <%= f.text_area :body, :class=>"form-control", :placeholder => "Enter comment text..." %>
        </div>
      </p>
      <p><%= f.submit "Add Comment", :class => "btn btn-primary pull-right" %></p>
    <% end %>
  </div>
</div>


<h3>Comments</h3>

<div id="comments">
  <% if @post.comments.count > 0 %>

    <% @post.comments.desc.each do |comment| %>
      <%= render partial: 'comments/comment', locals: { comment: comment } %>
    <% end %>
    
  <% else %>
    <em id="none-holder" style="font-weight: 200;">No comments</em>
  <% end %>

</div>